# Projektrisikomanagement
> Bewusstes Einbeziehen und Bewältigen von möglichen, projektbezogenen Störfällen
> 
> Erfassung, Bewertung und Verfolgung von projektbezogenen Risiken

**Sollte vor und während des Projekts erfolgen**


## Warum Risikomanagement
- Begrenzte Ressourcen werden auf gefährdende Aspekte begrenzt
- verhindert Probleme
  - reduziert somit Zeit
- verbessert Wahrscheinlichkeit, die Produkte dem Kunden rechtzeitig zu liefern
- Schätzungen und Projektpläne sind zuverlässiger
- Überraschungen im Projekt sind seltener
- macht die Eigner von Risiken für alle Parteien klar

## Perspektiven des Risikomanagements

|                      | Strategie / Projektportfolio                                            | Projektabwicklung / Operativ                                                                                                          |
|----------------------|-------------------------------------------------------------------------|---------------------------------------------------------------------------------------------------------------------------------------|
| Beschreibung         | welche IT-Projekt enthalten welche Risiken/Chancen                      |                                                                                                                                       |
| Ziele                | vor Projektanfang bereits Risiken finden                                | Risiken frühzeitig erkennen, behandeln                                                                                                |
| Aufgabe              | übernimmt Identifikation, Analyse, Bewertung und Behandlung von Risiken | Identifikation, Analyse, Bewertung und Behandlung von Risiken                                                                         |
| Verantwortung bei... | IT-Projektrisikomanagement                                              | (Teil-) Projektleiter                                                                                                                 |
| Beispiele            | ![image_846.png](image_846.png) ![image_847.png](image_847.png)         | krankheitsbedingte Verzögerungen, technische Risiken, nicht fristgerechte Leistung von Externen, strukturelle Risiken (Kommunikation) |


## Risikoarten /-kategorien
| Technisch                    | Organisation/Menschen                | Extern                                | Projektmanagement           |
|------------------------------|--------------------------------------|---------------------------------------|-----------------------------|
| Anforderung                  | Abhängigkeiten                       | Kunden (Akzeptanz, Nutzung, Know-How) | Schätzungen                 |
| Technologie                  | Ressourcen (Verfügbarkeit, Know-How) | Lieferanten                           | Planungen (Termine, Kosten) |
| Komplexität, Schnittstellen  | Finanzierung                         | Regulatorische Risiken, Verträge      | Controlling                 |
| Performance, Zuverlässigkeit | Priorisierung                        |                                       | Kommunikation               |
| Qualität                     |                                      |                                       |                             |

## Top-10-Risiken

| Risiko                         | Abschwächungsidee                                                  |
|--------------------------------|--------------------------------------------------------------------|
| Unzureichende Organisation     | Rollenbeschreibungen, abgestimmte Aufgabenmatrix, externe Beratung |
| Falsche/fehlende Anforderungen | Produktmanagement, Use-Cases, Benutzer-Mitarbeit                   |
| Ändernde Anforderungen         | Produktmanagement                                                  |
| Unrealistische Planung         | Agile Entwicklung, Detaillierte Kostenschätzung                    |
| Personelle Schwächen           | Fähigkeiten beachten, beste Fähigkeiten einsetzen                  |
| Over-Engineering               | Prototypen                                                         |
| Lieferanten-Probleme           | Inspektionen                                                       |
| Fehler/Qualitätsmangel         | Schnittstellenkontrolle, Verträge, Teams                           |
| Architekturdefizite            | externe Beratung                                                   | 
| Technologiekomplexität         | externe Beratung                                                   |

## Schritte des Risikomanagements
![image_848.png](image_848.png)

## Risikobewertung
> $Risiko = Schadenspotential * Eintrittswahrscheinlichkeit$

## Risikobehandlung
![image_849.png](image_849.png)

### Umgang mit Chancen (positive Risiken)
![image_850.png](image_850.png)

