# Scrum
## Was ist Scrum?
> Scrum = agiles Framework für Projektmanagement & Softwareentwicklung
- Fokus auf Transparenz, Inspektion, Anpassung
- **Hauptrollen**:
    - [Product Owner](#product-owner) (setzt Prioritäten, pflegt Product Backlog)
    - [Scrum Master](#scrum-master) (Moderation, Hindernisse beseitigen)
    - Entwicklungsteam (setzt die Arbeit um)
- **Artefakte**:
    - Product Backlog (gesamte Anforderungen)
    - Sprint Backlog (Arbeitsumfang für Sprint)
    - Inkrement (fertiges Produkt am Ende eines Sprints)
- **Ereignisse**:
    - Sprint (Zeitfenster von 1–4 Wochen)
    - [Sprint Planning](#sprint-planning) (Sprint-Ziele & Aufgaben festlegen)
    - [Daily Scrum](#daily-scrum) (kurzes tägliches Teammeeting)
    - [Sprint Review](#sprint-review) (Ergebnisse präsentieren)
    - Sprint Retrospective (Reflexion & Verbesserung)

[Video](https://www.youtube.com/watch?v=sWxjxn0Zx7c)


## Die Rollen in Scrum
- 3 Hauptrollen im Scrum:

    - **[Product Owner](#product-owner)**: Anforderungen priorisieren, Stakeholder-Vertreter
    - **[Scrum Master](#scrum-master)**: Prozesscoach, Team unterstützen, Hindernisse aus dem Weg räumen
    - **Entwicklungsteam**: interdisziplinär, liefert fertige Inkremente
- Klare Rollenverteilung sichert Erfolg

[Video](https://www.youtube.com/watch?v=feF2GDXSX7c)



### Scrum Master
> Scrum Master = Facilitator & Coach
- Aufgaben:
    - Scrum-Regeln vermitteln & sicherstellen
    - Hindernisse für das Team entfernen
    - Scrum Events moderieren
    - Team bei Selbstorganisation unterstützen
- Fokus auf kontinuierliche Verbesserung

[Video](https://www.youtube.com/watch?v=pMSsEDGJMCI)



### Product Owner
> Product Owner = Stimme der Kunden & Stakeholder
- Verantwortlich für:
    - Erstellung & Pflege des Product Backlogs
    - Priorisierung der Anforderungen
    - Sicherstellen, dass das Team den höchsten Wert liefert
    - Kommunikation mit Stakeholdern
- Entscheidungsbefugnis über Features & Releases

[Video](https://www.youtube.com/watch?v=X7Yg44wvAL4)


## Daily Scrum
- Tägliches 15-minütiges Team-Meeting
- Fragen:
    1. Was habe ich seit gestern getan?
    2. Was werde ich heute tun?
    3. Gibt es Hindernisse?
- Ziel: Transparenz, Abstimmung & schnelle Problemerkennung

[Video](https://www.youtube.com/watch?v=qCBLccfcgOI)


## Sprints
### Sprint Planning
- Planung des kommenden Sprints (1–4 Wochen)
- Beteiligte: gesamtes Scrum Team
- **Inhalte**:
    - Auswahl der Backlog Items für Sprint
    - Sprintziel definieren
    - Arbeitsaufteilung & Aufgabenverteilung
- **Wichtig**: realistische Planung & klare Ziele

[Video](https://www.youtube.com/watch?v=lF5xbHcwDB8)



### Sprint Review
- Am Ende des Sprints: Präsentation der Ergebnisse
- Beteiligte: Team + Stakeholder
- Feedbackrunde: Was wurde erreicht?
- Anpassung Product Backlog aufgrund Feedback
- Ziel: Transparenz & kontinuierliche Verbesserung

[Video](https://www.youtube.com/watch?v=GGbsgs611MM)