# Switching, VLAN, IP-in-IP-Tunneling, VPN
## Switching
> Prozess, der Daten von einem **input Interface (Port)** zu einem **output Interface (Port)** transferiert
> 
> Beruht darauf, dass Sender und Empfänger direkt miteinander verbunden sind
> 
> Zentrale (Switching Factory) muss in der Lage sein, eine Verbindung zwischen den Ports herzustellen


### Switch (Definition)
> Weiterentwicklung einer Bridge, arbeitet ebenfalls auf L2
> 
> verwendet MAC-Adressen zur Zustellung der Daten

#### Bridge vs Switch
> Bridge kann Bandbreite und Performance **im Gesamtnetz** verbessern
> 
> Leitet Daten nur weiter, wenn es von Segment zu Segment ist

> Switch kann Bandbreite und Performance **innerhalb eines Segments** verbessern
> 
> direkte und dedizierte Verbindungen zwischen den Ports


#### Switch-Typen
##### Cut-Through-Switches (CT)
- schnelle Durchleitung, kurze Latenzzeiten
- Puffern von ankommenden Frames bis zum Empfang der MAC-Zieladresse
- **Keine Fehlererkennung, Filtermechanismen**

##### Store-and-Forward-Switches (SF)
- Puffern auch
- können Filtern und Fehler erkennen


#### Managed L2 vs. Managed L3 Switch
|                                  | **Managed L2**                                                                                | **Managed L3**                                                                                                                      |
|----------------------------------|-----------------------------------------------------------------------------------------------|-------------------------------------------------------------------------------------------------------------------------------------|
| Fähigkeiten                      | Switching<br/>innerhalb desselben VLANs/Subnetzes                                             | Routing, Inter-VLAN-Routing<br/>kann zwischen verschiedenen VLANs, Subnetzen routen (IP-basiert)                                    |
| Routing-Protokolle               | Keine                                                                                         | diverse unterstützt, um dynamisches Routing zu unterstützen                                                                         |
| VLANs / Routing                  | kann VLANs erstellen, verwalten                                                               | kann VLANs erstellen, verwalten und Routing zwischen ihnen durchführen                                                              |
| Zugangskontrolle/Sicherheit      | Basis ACLs auf L2                                                                             | ACLs auf IP-Ebene → feinere Zugriffssteuerung                                                                                       |
| Management                       | einfache Optionen                                                                             | komplexere Optionen verfügbar um effizient Verkehr zu lenekne und zu kontrollieren                                                  |
| **QoS**                          | Basis (basiert auf VLAN-Tags)                                                                 | Erweitert (auf L3-Informationen basiert)                                                                                            |
| QoS Datenverkehrsklassifizierung | mittels VLAN IEEE 802.1Q Tagging<br/> Ethernet-Frames enthalten VLAN-Tags, die Prio enthalten | L2, IP-Header, Protokolle, Portnummer, Inhalt von Datenpaketen                                                                      |
| QoS Markierung und Priorisierung | Setzen/Ändern des PCP-Wertes (Prio) im VLAN Tag                                               | Prio im IP-Header<br/>(genauer, da 0-63 nicht 0-7 mögliche Werte)                                                                   |
| QoS Warteschlangenmanagement     | mehrere Hardware-Warteschlangen pro Port<br/>Frames mit hoher Prio werden vorne eingereiht    | mehrere Warteschlangen für ausgehenden Verkehr<br/>je nach Prio einsortiert                                                         |
| QoS Planung (Scheduling)         | Round-Robin oder Weighted Fair Queuing<br/>Prio früher                                        | Weighted-Fair-Queuing, Class-Based WFQ, Low Latency Queuing                                                                         |
| QoS Verkehrsformung und Policing | nur auf fortgeschrittenen Geräten                                                             | Datenflussrate begrenzen (Datenströme können Bandbreite nicht überschreiten)<br/>übermäßiger Datenverkehr wird gedrosselt/verworfen |
| QoS Congestion Management        |                                                                                               | Bei Netzwerküberlastung:<br/>(Weighted) Random Early Detection um Stauungen zu verwalten/verhindern                                 |


## VLAN
> VLANs unterteilen bestehendes, einzelnes, **physisches Netzwerk in mehrere logische Netzwerke**
> 
> VLAN entspricht **einer Broadcast-Domäne**
> 
> können sich **über mehrere Switche hinweg** strecken

### Gruppierungsmöglichkeiten
- Port-basierend
- MAC-basierend
- Netzwerkprotokoll-basierend
- Switching mit Netzwerkadressen (L3 Switching)
  - Information im Header der Netzwerkschicht entscheidet

### Optimierung mit VLANs
> Alles weg und Managed-Layer-3 Switche hin
> 
> "Normale Switche" zu "VLAN-Switchen"

![image_851.png](image_851.png)
![image_852.png](image_852.png)


## IP-in-IP-Tunneling (nicht klausurrelevant)
### Tunnel
![image_853.png](image_853.png)
> (logisch) geschützter Kanal für Datenpakete zwischen Eingang und Ausgang
> 
> IP-Paket in einem weiteren IP-Paket gekapselt:
> äußerer Header adressiert Tunnelenden, sieht aus wie Nutzdaten, 
> bis er vom Tunnelende entpackt wird und kann dann weitergeleitet werden