# IP-Routing und IP-QoS
## Weiterleitung vs. Routing
- **Weiterleitung**
  - Zieladresse eines Pakets in Tabelle
  - Paket in Richtung schicken, die auch in Tabelle steht
  - _lokal in einem Knoten_
- **Routing**
  - Weiterleitungstabellen erstellen
  - hängt von komplex verteilten Algorithmen ab

## Routing vs. Switching
> |                 | **Router** | **Switch**    |
> |-----------------|------------|---------------|
> | Geschwindigkeit | langsamer  | schneller     |
> | OSI             | L3         | L2            |
> | Adressierung    | IP         | MAC           |
> | Broadcasts      | blockiert  | leitet weiter |
> | Sicherheit      | hoch       | niedrig       |


## QoS Parameter (!!!KLAUSUR!!!)
### Throughput
- [bytes/s]
- min/max/avg benötigter Durchsatz

### Packet Loss
### Delay
- [ms]
- max tolerierbare Verzögerung
- One-Way-Delay
- Round-Trip-Delay (RTT)

### Jitter (=Delay Variation)
- [ms]
- Welche Fluktuationen in der Verzögerung sind akzeptierbar?

### Availability
- [%]
- Mit welcher Wahrscheinlichkeit ist der Service verfügbar?
    - manchmal "five times 9" = 99,999% der Zeit


## ab hier laut Massoth nicht wichtig
## QoS Building Blocks (Bestandteil eines Traffic Conditioner Blocks TCP)
- **Klassifizierer**
  - Klassifiziert Pakete
    - individuell/ gehören zu einem Flow / Service-Klasse
- **Shaper**
  - Buffert eingehenden (teilweise zu schnellen) Traffic
  - Lässt ihn dann in akzeptierter Geschwindigkeit durch
  - ![image_854.png](image_854.png)
- **Policer**
  - Vergleicht eingehenden Traffic mit Regeln
  - Verwirft Pakete, die zu viel sind
  - ![image_855.png](image_855.png)
- **Scheduler**
  - Queuing Strategie
  - wird von Router gewartet
  - enthält diverse Warteschlangen
- **Dropper**
  - Verwirft Pakete

## Leaky and Token Bucket Algorithmus
### Leaky Bucket
![image_857.png](image_857.png)
### Token Bucket
![image_858.png](image_858.png)
### Wirkung Beispiel
![image_856.png](image_856.png)

## IP-Flow
- Identifikation basierend auf
  - Source-IP
  - Destination-IP
  - Protokoll-Feld
  - Source-Port
  - Destination-Port

